# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#
############################################################################
#    Coded by:
#       Jorge Alfonso Medina Uriarte (desarrollo.sacsa@gruposacsa.com.mx)
############################################################################
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp import fields, models, api, _
#from openerp.exceptions import Warning
from datetime import time


class mrp_update_policy(models.TransientModel):
    _name = 'mrp.update.policy'
    
    @api.multi
    def update_policy(self):
         #actualiza el production_id en el movimiento contable
        self.env.cr.execute("""
            UPDATE account_move_line SET production_id = mrp.id 
            FROM mrp_production mrp
            WHERE account_move_line.name = mrp.name AND mrp.state = 'done'
                AND account_move_line.production_id IS NULL; 
            """)
        #llena el campo del production_id y la referencia en el encabezado de la poliza contable
        self.env.cr.execute("""
            UPDATE account_move SET production_id = tmp.production_id, ref = tmp.name
            FROM 
            (
                            SELECT  move_id, production_id, name, COUNT(*) FROM account_move_line
                            WHERE production_id IS NOT NULL
                            GROUP BY move_id, production_id, name
            ) tmp
            WHERE account_move.id = tmp.move_id AND account_move.production_id IS NULL;
        """)
        #actualiza los cargos (debit) de las polizas de productos terminados
        self.env.cr.execute("""
            UPDATE account_move_line SET debit = tmp.DebitMP
            FROM 
            (
                SELECT ml.id, ml.name, ml.debit DebitPT, ml.credit CreditPT, 
                                           vdet.debit DebitMP, vdet.credit CreditMP, ABS(ml.debit - vdet.debit) 
                            FROM account_move_line ml INNER JOIN mrp_production mrp ON (ml.production_id = mrp.id)
                                           INNER JOIN v_mrp_account_valuation vdet ON (ml.production_id = vdet.id)
                            WHERE ml.state = 'valid' AND ml.product_id = mrp.product_id AND ml.debit > 0 AND ABS(ml.debit-vdet.debit) >= 0.36
            ) tmp
            WHERE account_move_line.id = tmp.id;
        """)
        #actualiza los abonos (credit) de las polizas de productos terminados
        self.env.cr.execute("""
            UPDATE account_move_line SET credit = tmp.CreditMP
            FROM
            (
                SELECT ml.id, ml.name, ml.debit DebitPT, ml.credit CreditPT, 
                                           vdet.debit DebitMP, vdet.credit CreditMP, ABS(ml.debit - vdet.debit) 
                            FROM account_move_line ml INNER JOIN mrp_production mrp ON (ml.production_id = mrp.id)
                                           INNER JOIN v_mrp_account_valuation vdet ON (ml.production_id = vdet.id)
                            WHERE ml.state = 'valid' AND ml.product_id = mrp.product_id AND ml.credit > 0 AND ABS(ml.credit-vdet.credit) >= 0.36
            ) tmp
            WHERE account_move_line.id = tmp.id;
        """)
        return True
